| QxOrm 1.5.0 C++ Object Relational Mapping library

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories

Classes | Namespaces | Files | Functions
QxSerialize : QxOrm library serialization engine based on 'boost::serialization' library

## Classes
class | qx::QxArchive_ToFile< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_ToFile : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_FromFile< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_FromFile : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_ToFileCompressed< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_ToFileCompressed : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_FromFileCompressed< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_FromFileCompressed : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_ToString< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_ToString : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_FromString< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_FromString : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_ToByteArray< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_ToByteArray : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::QxArchive_FromByteArray< T, ArchiveInput, ArchiveOutput >
| qx::QxArchive_FromByteArray : provide some tools to serialize a class registered into QxOrm context into/from binary/text/XML archives (file, string, etc.) More...
class | qx::serialization::helper::QxSerializeCheckInstance
| qx::serialization::helper::QxSerializeCheckInstance : check instance during serialization process to avoid infinite loop with circular references (using RAII) More...
## Namespaces
namespace | qx::serialization
| QxOrm library serialization engine based on boost::serialization library.
namespace | qx::serialization::detail
| Internal helper tools for qx::serialization namespace.
namespace | qx::serialization::wide
| QxOrm library serialization engine for wide archive.
namespace | qx::serialization::polymorphic_binary
| serialize a class registered into QxOrm context into/from polymorphic_binary archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_POLYMORPHIC compilation options in QxOrm.pri configuration file
namespace | qx::serialization::polymorphic_text
| serialize a class registered into QxOrm context into/from polymorphic_text archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_POLYMORPHIC compilation options in QxOrm.pri configuration file
namespace | qx::serialization::polymorphic_xml
| serialize a class registered into QxOrm context into/from polymorphic_xml archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_POLYMORPHIC compilation options in QxOrm.pri configuration file
namespace | qx::serialization::binary
| serialize a class registered into QxOrm context into/from binary archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_BINARY compilation options in QxOrm.pri configuration file
namespace | qx::serialization::text
| serialize a class registered into QxOrm context into/from text archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_TEXT compilation options in QxOrm.pri configuration file
namespace | qx::serialization::xml
| serialize a class registered into QxOrm context into/from XML archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_XML compilation options in QxOrm.pri configuration file
namespace | qx::serialization::portable_binary
| serialize a class registered into QxOrm context into/from portable_binary archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_PORTABLE_BINARY compilation options in QxOrm.pri configuration file
namespace | qx::serialization::wide::binary
| serialize a class registered into QxOrm context into/from wide binary archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_WIDE_BINARY compilation options in QxOrm.pri configuration file
namespace | qx::serialization::wide::text
| serialize a class registered into QxOrm context into/from wide text archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_WIDE_TEXT compilation options in QxOrm.pri configuration file
namespace | qx::serialization::wide::xml
| serialize a class registered into QxOrm context into/from wide XML archive (file, string, etc.) : enable this feature defining _QX_ENABLE_BOOST_SERIALIZATION and _QX_ENABLE_BOOST_SERIALIZATION_WIDE_XML compilation options in QxOrm.pri configuration file
namespace | qx::serialization::qt
| serialize a class registered into QxOrm context using Qt QDataStream serialization engine
namespace | qx::serialization::json
| serialize a class registered into QxOrm context using Qt QJson serialization engine (this feature requires Qt5)
## Files
file | QxSerializeQDataStream_all_include.h
| Include all Qt QDataStream serialization method (save/load) provided by QxOrm library.
file | QxSerializeQDataStream_boost_optional.h
| Provide a Qt QDataStream serialization method (save/load) for type boost::optional<T>
file | QxSerializeQDataStream_boost_scoped_ptr.h
| Provide a Qt QDataStream serialization method (save/load) for type boost::scoped_ptr<T>
file | QxSerializeQDataStream_boost_shared_ptr.h
| Provide a Qt QDataStream serialization method (save/load) for type boost::shared_ptr<T>
file | QxSerializeQDataStream_boost_tuple.h
| Provide a Qt QDataStream serialization method (save/load) for type boost::tuple<T0, T1, ..., T9>
file | QxSerializeQDataStream_boost_unordered_map.h
| Provide a Qt QDataStream serialization method (save/load) for type boost::unordered_map<Key, Value> and boost::unordered_multimap<Key, Value>
file | QxSerializeQDataStream_boost_unordered_set.h
| Provide a Qt QDataStream serialization method (save/load) for type boost::unordered_set<T> and boost::unordered_multiset<T>
file | QxSerializeQDataStream_primitive_type.h
| Provide a Qt QDataStream serialization method (save/load) for primitive types (long, etc...)
file | QxSerializeQDataStream_QFlags.h
| Provide a Qt QDataStream serialization method (save/load) for type QFlags<T>
file | QxSerializeQDataStream_QObject.h
| Provide a Qt QDataStream serialization method (save/load) for type QObject (serialize dynamic properties)
file | QxSerializeQDataStream_QScopedPointer.h
| Provide a Qt QDataStream serialization method (save/load) for type QScopedPointer<T>
file | QxSerializeQDataStream_QSharedPointer.h
| Provide a Qt QDataStream serialization method (save/load) for type QSharedPointer<T>
file | QxSerializeQDataStream_QSqlError.h
| Provide a Qt QDataStream serialization method (save/load) for type QSqlError.
file | QxSerializeQDataStream_QWeakPointer.h
| Provide a Qt QDataStream serialization method (save/load) for type QWeakPointer<T>
file | QxSerializeQDataStream_qx_registered_class.h
| Provide a generic Qt QDataStream serialization method (save/load) for classes registered into QxOrm context (void qx::register_class<MyClass>() function), it is possible to specialize qx::QxSerializeRegistered<T> template to implement your own serialization method for a specific class.
file | QxSerializeQDataStream_std_list.h
| Provide a Qt QDataStream serialization method (save/load) for type std::list<T>
file | QxSerializeQDataStream_std_map.h
| Provide a Qt QDataStream serialization method (save/load) for type std::map<Key, Value>
file | QxSerializeQDataStream_std_set.h
| Provide a Qt QDataStream serialization method (save/load) for type std::set<T>
file | QxSerializeQDataStream_std_shared_ptr.h
| Provide a Qt QDataStream serialization method (save/load) for type std::shared_ptr<T> (C++11 compilation option _QX_CPP_11_SMART_PTR must be defined)
file | QxSerializeQDataStream_std_string.h
| Provide a Qt QDataStream serialization method (save/load) for type std::string and std::wstring.
file | QxSerializeQDataStream_std_tuple.h
| Provide a Qt QDataStream serialization method (save/load) for type std::tuple<T0, T1, ..., T9> (C++11 compilation option _QX_CPP_11_TUPLE must be defined)
file | QxSerializeQDataStream_std_unique_ptr.h
| Provide a Qt QDataStream serialization method (save/load) for type std::unique_ptr<T> (C++11 compilation option _QX_CPP_11_SMART_PTR must be defined)
file | QxSerializeQDataStream_std_unordered_map.h
| Provide a Qt QDataStream serialization method (save/load) for type std::unordered_map<Key, Value> and std::unordered_multimap<Key, Value> (C++11 compilation option _QX_CPP_11_CONTAINER must be defined)
file | QxSerializeQDataStream_std_unordered_set.h
| Provide a Qt QDataStream serialization method (save/load) for type std::unordered_set<T> and std::unordered_multiset<T> (C++11 compilation option _QX_CPP_11_CONTAINER must be defined)
file | QxSerializeQDataStream_std_vector.h
| Provide a Qt QDataStream serialization method (save/load) for type std::vector<T>
file | QxSerializeQJson_all_include.h
| Include all Qt QJson serialization method (save/load) provided by QxOrm library.
file | QxSerializeQJson_boost_scoped_ptr.h
| Provide a Qt QJson serialization method (save/load) for type boost::scoped_ptr<T>
file | QxSerializeQJson_boost_shared_ptr.h
| Provide a Qt QJson serialization method (save/load) for type boost::shared_ptr<T>
file | QxSerializeQJson_boost_tuple.h
| Provide a Qt QJson serialization method (save/load) for type boost::tuple<T0, T1, ..., T9>
file | QxSerializeQJson_boost_unordered_map.h
| Provide a Qt QJson serialization method (save/load) for type boost::unordered_map<Key, Value> and boost::unordered_multimap<Key, Value>
file | QxSerializeQJson_boost_unordered_set.h
| Provide a Qt QJson serialization method (save/load) for type boost::unordered_set<T> and boost::unordered_multiset<T>
file | QxSerializeQJson_IxParameter.h
| Provide a Qt QJson serialization method (save/load) for type qx::service::IxParameter.
file | QxSerializeQJson_IxPersistable.h
| Provide a Qt QJson serialization method (save/load) for type qx::IxPersistable.
file | QxSerializeQJson_IxService.h
| Provide a Qt QJson serialization method (save/load) for type qx::service::IxService.
file | QxSerializeQJson_IxSqlElement.h
| Provide a Qt QJson serialization method (save/load) for type qx::dao::detail::IxSqlElement.
file | QxSerializeQJson_QBrush.h
| Provide a Qt QJson serialization method (save/load) for type QBrush.
file | QxSerializeQJson_QColor.h
| Provide a Qt QJson serialization method (save/load) for type QColor.
file | QxSerializeQJson_QFlags.h
| Provide a Qt QJson serialization method (save/load) for type QFlags<T>
file | QxSerializeQJson_QFont.h
| Provide a Qt QJson serialization method (save/load) for type QFont.
file | QxSerializeQJson_QHash.h
| Provide a Qt QJson serialization method (save/load) for type QHash<Key, Value>
file | QxSerializeQJson_QImage.h
| Provide a Qt QJson serialization method (save/load) for type QImage.
file | QxSerializeQJson_QList.h
| Provide a Qt QJson serialization method (save/load) for type QList<T>
file | QxSerializeQJson_QMap.h
| Provide a Qt QJson serialization method (save/load) for type QMap<Key, Value>
file | QxSerializeQJson_QMultiHash.h
| Provide a Qt QJson serialization method (save/load) for type QMultiHash<Key, Value>
file | QxSerializeQJson_QMultiMap.h
| Provide a Qt QJson serialization method (save/load) for type QMultiMap<Key, Value>
file | QxSerializeQJson_QObject.h
| Provide a Qt QJson serialization method (save/load) for type QObject (serialize dynamic properties)
file | QxSerializeQJson_QPicture.h
| Provide a Qt QJson serialization method (save/load) for type QPicture.
file | QxSerializeQJson_QPixmap.h
| Provide a Qt QJson serialization method (save/load) for type QPixmap.
file | QxSerializeQJson_QPoint.h
| Provide a Qt QJson serialization method (save/load) for type QPoint.
file | QxSerializeQJson_QRect.h
| Provide a Qt QJson serialization method (save/load) for type QRect.
file | QxSerializeQJson_QRegion.h
| Provide a Qt QJson serialization method (save/load) for type QRegion.
file | QxSerializeQJson_QScopedPointer.h
| Provide a Qt QJson serialization method (save/load) for type QScopedPointer<T>
file | QxSerializeQJson_QSharedPointer.h
| Provide a Qt QJson serialization method (save/load) for type QSharedPointer<T>
file | QxSerializeQJson_QSize.h
| Provide a Qt QJson serialization method (save/load) for type QSize.
file | QxSerializeQJson_QSqlError.h
| Provide a Qt QJson serialization method (save/load) for type QSqlError.
file | QxSerializeQJson_QStringList.h
| Provide a Qt QJson serialization method (save/load) for type QStringList.
file | QxSerializeQJson_QUrl.h
| Provide a Qt QJson serialization method (save/load) for type QUrl.
file | QxSerializeQJson_QVariantHash.h
| Provide a Qt QJson serialization method (save/load) for type QVariantHash.
file | QxSerializeQJson_QVariantMap.h
| Provide a Qt QJson serialization method (save/load) for type QVariantMap.
file | QxSerializeQJson_QWeakPointer.h
| Provide a Qt QJson serialization method (save/load) for type QWeakPointer<T>
file | QxSerializeQJson_qx_registered_class.h
| Provide a generic Qt QJson serialization method (save/load) for classes registered into QxOrm context (void qx::register_class<MyClass>() function), it is possible to specialize qx::cvt::detail::QxSerializeJsonRegistered<T> template to implement your own serialization method for a specific class.
file | QxSerializeQJson_QxCollection.h
| Provide a Qt QJson serialization method (save/load) for type qx::QxCollection<Key, Value>
file | QxSerializeQJson_QxDaoPointer.h
| Provide a Qt QJson serialization method (save/load) for type qx::dao::ptr<T>
file | QxSerializeQJson_QxInvalidValue.h
| Provide a Qt QJson serialization method (save/load) for type qx::QxInvalidValue.
file | QxSerializeQJson_QxInvalidValueX.h
| Provide a Qt QJson serialization method (save/load) for type qx::QxInvalidValueX.
file | QxSerializeQJson_QxSqlQuery.h
| Provide a Qt QJson serialization method (save/load) for type qx::QxSqlQuery.
file | QxSerializeQJson_QxTransaction.h
| Provide a Qt QJson serialization method (save/load) for type qx::service::QxTransaction.
file | QxSerializeQJson_std_list.h
| Provide a Qt QJson serialization method (save/load) for type std::list<T>
file | QxSerializeQJson_std_map.h
| Provide a Qt QJson serialization method (save/load) for type std::map<Key, Value>
file | QxSerializeQJson_std_pair.h
| Provide a Qt QJson serialization method (save/load) for type std::pair<T1, T2>
file | QxSerializeQJson_std_set.h
| Provide a Qt QJson serialization method (save/load) for type std::set<T>
file | QxSerializeQJson_std_shared_ptr.h
| Provide a Qt QJson serialization method (save/load) for type std::shared_ptr<T> (C++11 compilation option _QX_CPP_11_SMART_PTR must be defined)
file | QxSerializeQJson_std_tuple.h
| Provide a Qt QJson serialization method (save/load) for type std::tuple<T0, T1, ..., T9> (C++11 compilation option _QX_CPP_11_TUPLE must be defined)
file | QxSerializeQJson_std_unique_ptr.h
| Provide a Qt QJson serialization method (save/load) for type std::unique_ptr<T> (C++11 compilation option _QX_CPP_11_SMART_PTR must be defined)
file | QxSerializeQJson_std_unordered_map.h
| Provide a Qt QJson serialization method (save/load) for type std::unordered_map<Key, Value> and std::unordered_multimap<Key, Value> (C++11 compilation option _QX_CPP_11_CONTAINER must be defined)
file | QxSerializeQJson_std_unordered_set.h
| Provide a Qt QJson serialization method (save/load) for type std::unordered_set<T> and std::unordered_multiset<T> (C++11 compilation option _QX_CPP_11_CONTAINER must be defined)
file | QxSerializeQJson_std_vector.h
| Provide a Qt QJson serialization method (save/load) for type std::vector<T>
file | QxArchive.h
| Provide some tools to serialize a class registered into QxOrm context into/from binary/XML archive (file, string, etc.)
file | QxClone.h
| Clone all classes registered into QxOrm context using QxOrm library serialization engine.
file | QxDump.h
| Dump all classes registered into QxOrm context using XML and JSON serialization engine.
file | QxSerialize.h
| Include all files necessary to serialize most used classes defined into stl, boost and Qt libraries.
file | QxSerializeCheckInstance.h
| Check instance during serialization process to avoid infinite loop with circular references (using RAII)
file | QxSerializeQDataStream.h
| Used when _QX_ENABLE_BOOST_SERIALIZATION compilation option is not defined to provide serialization engine with Qt QDataStream class.
file | QxSerializeQJson.h
| Provide a serialization engine with Qt QJson classes (this feature requires Qt5)
## Functions
template<class T >
T * | qx::clone_to_nude_ptr (const T &obj)
| qx::clone_to_nude_ptr(const T & obj) : return a nude pointer (be careful with memory leak) of a new instance of type T cloned from obj
template<class T >
std::shared_ptr< T > | qx::clone (const T &obj)
| qx::clone(const T & obj) : return a boost smart-pointer (std::shared_ptr<T>) of a new instance of type T cloned from obj
template<class T >
boost::shared_ptr< T > | qx::clone_to_boost_shared_ptr (const T &obj)
| qx::clone_to_boost_shared_ptr(const T & obj) : return a boost smart-pointer (boost::shared_ptr<T>) of a new instance of type T cloned from obj
template<class T >
QSharedPointer< T > | qx::clone_to_qt_shared_ptr (const T &obj)
| qx::clone_to_qt_shared_ptr(const T & obj) : return a Qt smart-pointer (QSharedPointer<T>) of a new instance of type T cloned from obj
template<class T >
std::shared_ptr< T > | qx::clone_to_std_shared_ptr (const T &obj)
| qx::clone_to_std_shared_ptr(const T & obj) : return a C++11 std smart-pointer (std::shared_ptr<T>) of a new instance of type T cloned from obj
template<class T >
void | qx::dump (const T &t, bool bJsonFormat=false)
| qx::dump(const T & t, bool bJsonFormat) : dump class of type T registered into QxOrm context using XML and JSON serialization engine

## Function Documentation

template<class T >

std::shared_ptr<T> qx::clone | ( | const T & | obj | ) |

qx::clone(const T & obj) : return a boost smart-pointer (std::shared_ptr<T>) of a new instance of type T cloned from obj

Definition at line 128 of file QxClone.h.

template<class T >

boost::shared_ptr<T> qx::clone_to_boost_shared_ptr | ( | const T & | obj | ) |

qx::clone_to_boost_shared_ptr(const T & obj) : return a boost smart-pointer (boost::shared_ptr<T>) of a new instance of type T cloned from obj

Definition at line 138 of file QxClone.h.

template<class T >

T* qx::clone_to_nude_ptr | ( | const T & | obj | ) |

qx::clone_to_nude_ptr(const T & obj) : return a nude pointer (be careful with memory leak) of a new instance of type T cloned from obj

Definition at line 78 of file QxClone.h.

template<class T >

QSharedPointer< T > qx::clone_to_qt_shared_ptr | ( | const T & | obj | ) |

qx::clone_to_qt_shared_ptr(const T & obj) : return a Qt smart-pointer (QSharedPointer<T>) of a new instance of type T cloned from obj

Definition at line 148 of file QxClone.h.

template<class T >

std::shared_ptr<T> qx::clone_to_std_shared_ptr | ( | const T & | obj | ) |

qx::clone_to_std_shared_ptr(const T & obj) : return a C++11 std smart-pointer (std::shared_ptr<T>) of a new instance of type T cloned from obj

Definition at line 156 of file QxClone.h.

template<class T >

void qx::dump | ( | const T & | t,
|  | bool | bJsonFormat = `false`
| ) |  |

qx::dump(const T & t, bool bJsonFormat) : dump class of type T registered into QxOrm context using XML and JSON serialization engine

Definition at line 63 of file QxDump.h.